<?php
/**
 * Dog Groomer Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package dog_groomer
 */

if( ! function_exists( 'dog_groomer_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function dog_groomer_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Dog_Groomer_Control_Sortable' ); 
    
    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'dog-groomer' );
    }
	
    /* Option list of all post */	
    $dog_groomer_options_posts = array();
    $dog_groomer_options_posts_obj = get_posts('posts_per_page=-1');
    $dog_groomer_options_posts[''] = esc_html__( 'Choose Post', 'dog-groomer' );
    foreach ( $dog_groomer_options_posts_obj as $dog_groomer_posts ) {
    	$dog_groomer_options_posts[$dog_groomer_posts->ID] = $dog_groomer_posts->post_title;
    }
    
    /* Option list of all categories */
    $dog_groomer_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $dog_groomer_option_categories = array();
    $dog_groomer_category_lists = get_categories( $dog_groomer_args );
    $dog_groomer_option_categories[''] = esc_html__( 'Choose Category', 'dog-groomer' );
    foreach( $dog_groomer_category_lists as $dog_groomer_category ){
        $dog_groomer_option_categories[$dog_groomer_category->term_id] = $dog_groomer_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'dog-groomer' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'dog-groomer' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'dog-groomer' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'dog-groomer' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'dog-groomer'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'dog_groomer_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'dog_groomer_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'dog-groomer' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    /** Responsive Media settings */
    
    $wp_customize->add_section(
        'dog_groomer_responsive_media_section',
        array(
            'title' => esc_html__( 'Responsive Media Settings', 'dog-groomer' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_general_settings',
        )
    );

    /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'dog_groomer_resp_scroll_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_resp_scroll_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'dog-groomer' ),
            'section'     => 'dog_groomer_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

        /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'dog_groomer_resp_loader', 
        array(
            'default' => 0,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_resp_loader',
        array(
            'label'       => __( 'Show Preloader', 'dog-groomer' ),
            'section'     => 'dog_groomer_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

    /** Responsive Media Ends */

    /** Responsive Media Ends */

    //Global Color
    $wp_customize->add_section(
        'dog_groomer_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'dog-groomer' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_general_settings',
        )
    );

    $wp_customize->add_setting('dog_groomer_primary_color', array(
        'default'           => '#f5787b',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'dog_groomer_primary_color', array(
        'label'    => __('Theme Primary Color', 'dog-groomer'),
        'section'  => 'dog_groomer_global_color',
        'settings' => 'dog_groomer_primary_color',
    )));    

    $wp_customize->add_setting('dog_groomer_second_color', array(
        'default'           => '#ffdcdc',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'dog_groomer_second_color', array(
        'label'    => __('Theme Secondary Color', 'dog-groomer'),
        'section'  => 'dog_groomer_global_color',
        'settings' => 'dog_groomer_second_color',
    )));

    /** Post Layouts */

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'dog_groomer_home_post_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'dog-groomer' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'dog-groomer' ),
        ) 
    );
    
    $wp_customize->add_section(
        'dog_groomer_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'dog-groomer' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_post_settings',
        )
    );

    $wp_customize->add_setting('dog_groomer_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'dog_groomer_sanitize_post_layout',
    ));

    $wp_customize->add_control('dog_groomer_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'dog-groomer'),
        'section'  => 'dog_groomer_post_layout_section',
        'settings' => 'dog_groomer_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'dog-groomer'),
            'left-sidebar'   => __('Left Sidebar', 'dog-groomer'),
            'one-column'   => __('One Column', 'dog-groomer'),
            'three-column'   => __('Three Columns', 'dog-groomer'),
            'four-column'   => __('Four Columns', 'dog-groomer'),
            'grid-layout'   => __('Grid Layout', 'dog-groomer')
        ),
    ));


    $wp_customize->add_setting('dog_groomer_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'dog_groomer_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('dog_groomer_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','dog-groomer'),
        'section' => 'dog_groomer_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','dog-groomer'),
            'center-align' => __('Center Alignment','dog-groomer'),
            'left-align' => __('Left Alignment','dog-groomer'),
        ),
    ) );

     /** Post Layouts Ends */

    /** Post Settings */
    $wp_customize->add_section(
        'dog_groomer_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'dog-groomer' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'dog_groomer_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'dog-groomer' ),
            'section'     => 'dog_groomer_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'dog_groomer_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'dog-groomer' ),
            'section'     => 'dog_groomer_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'dog_groomer_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'dog-groomer' ),
            'section'     => 'dog_groomer_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'dog_groomer_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'dog-groomer' ),
            'section'     => 'dog_groomer_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'dog_groomer_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'dog_groomer_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'dog_groomer_post_settings', 
        'label'       => __( 'Display Read More Button', 'dog-groomer' ),
    ) );

     $wp_customize->add_setting('dog_groomer_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'dog_groomer_sanitize_single_post_align'
    ));
    $wp_customize->add_control('dog_groomer_single_post_align',array(
        'type' => 'select',
        'label' => __('Post Content Alignment','dog-groomer'),
        'section' => 'dog_groomer_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','dog-groomer'),
            'right-align' => __('Right Alignment','dog-groomer'),
            'center-align' => __('Center Alignment','dog-groomer'),
        ),
    ) );

    $wp_customize->add_setting('dog_groomer_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'dog_groomer_sanitize_sortable',
    ));
    $wp_customize->add_control(new Dog_Groomer_Control_Sortable($wp_customize, 'dog_groomer_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'dog-groomer'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'dog-groomer') ,
        'section' => 'dog_groomer_post_settings',
        'choices' => array(
            'heading' => __('heading', 'dog-groomer') ,
            'author' => __('author', 'dog-groomer') ,
            'featured-image' => __('featured-image', 'dog-groomer') ,
            'content' => __('content', 'dog-groomer') ,
            'button' => __('button', 'dog-groomer') ,
        ) ,
    )));

    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'dog_groomer_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'dog-groomer' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'dog_groomer_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'dog-groomer' ),
            'section'     => 'dog_groomer_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'dog_groomer_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'dog-groomer' ),
            'section'     => 'dog_groomer_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

         // Typography Settings Section
    $wp_customize->add_section('dog_groomer_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'dog-groomer'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'dog_groomer_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'dog-groomer'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('dog_groomer_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'dog_groomer_sanitize_choicess',
    ));
    $wp_customize->add_control('dog_groomer_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'dog-groomer'),
        'section' => 'dog_groomer_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('dog_groomer_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'dog_groomer_sanitize_choicess',
    ));
    $wp_customize->add_control('dog_groomer_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'dog-groomer'),
        'section' => 'dog_groomer_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'dog_groomer_general_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'dog-groomer' ),
            'description' => esc_html__( 'Customize General Settings', 'dog-groomer' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'dog_groomer_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'dog-groomer' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'dog_groomer_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'dog-groomer' ),
            'section'     => 'dog_groomer_general_settings',
            'type'        => 'checkbox',
        )
    );
    
    $wp_customize->add_setting('dog_groomer_theme_width',array(
        'default' => 'full-width',
        'sanitize_callback' => 'dog_groomer_sanitize_theme_width'
    ));
    $wp_customize->add_control('dog_groomer_theme_width',array(
        'type' => 'select',
        'label' => __('Theme Width Option','dog-groomer'),
        'section' => 'dog_groomer_general_settings',
        'choices' => array(
            'full-width' => __('Fullwidth','dog-groomer'),
            'container' => __('Container','dog-groomer'),
            'container-fluid' => __('Container Fluid','dog-groomer'),
        ),
    ) );

    /** Header Section Settings */
    $wp_customize->add_section(
        'dog_groomer_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'dog-groomer' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_page_settings',
        )
    );

        /** Appointment Button */
    $wp_customize->add_setting(
        'dog_groomer_header_btn_text',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'dog_groomer_header_btn_text',
        array(
            'label' => esc_html__( 'Add Button Text', 'dog-groomer' ),
            'section' => 'dog_groomer_header_section_settings',
            'type' => 'text',
        )
    );

    /** Appointment Button */
    $wp_customize->add_setting(
        'dog_groomer_header_btn_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'dog_groomer_header_btn_url',
        array(
            'label' => esc_html__( 'Add Button URL', 'dog-groomer' ),
            'section' => 'dog_groomer_header_section_settings',
            'type' => 'url',
        )
    );


    $wp_customize->add_setting( 
        'dog_groomer_show_hide_search', 
        array(
            'default' => false ,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_show_hide_search',
        array(
            'label'       => __( 'Show Search Icon', 'dog-groomer' ),
            'section'     => 'dog_groomer_header_section_settings',
            'type'        => 'checkbox',
        )
    );
    $wp_customize->add_setting('dog_groomer_search_icon',array(
        'default'   => 'fas fa-search',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Dog_Groomer_Changeable_Icon(
        $wp_customize,'dog_groomer_search_icon',array(
        'label' => __('Search Icon','dog-groomer'),
        'transport' => 'refresh',
        'section'   => 'dog_groomer_header_section_settings',
        'type'      => 'icon'
    )));

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'dog_groomer_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'dog-groomer' ),
            'section'     => 'dog_groomer_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'dog_groomer_menu_font_weight', array(
        'default'           => '700',
        'sanitize_callback' => 'dog_groomer_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'dog_groomer_menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'dog-groomer' ),
        'section'  => 'dog_groomer_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'dog-groomer' ),
            '200' => __( '200 - Extra Light', 'dog-groomer' ),
            '300' => __( '300 - Light', 'dog-groomer' ),
            '400' => __( '400 - Normal', 'dog-groomer' ),
            '500' => __( '500 - Medium', 'dog-groomer' ),
            '600' => __( '600 - Semi Bold', 'dog-groomer' ),
            '700' => __( '700 - Bold', 'dog-groomer' ),
            '800' => __( '800 - Extra Bold', 'dog-groomer' ),
            '900' => __( '900 - Black', 'dog-groomer' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'dog_groomer_menu_text_transform', array(
        'default'           => 'Capitalize',
        'sanitize_callback' => 'dog_groomer_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'dog_groomer_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'dog-groomer' ),
        'section'  => 'dog_groomer_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'dog-groomer' ),
            'capitalize' => __( 'Capitalize', 'dog-groomer' ),
            'uppercase'  => __( 'Uppercase', 'dog-groomer' ),
            'lowercase'  => __( 'Lowercase', 'dog-groomer' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('dog_groomer_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'dog_groomer_sanitize_choices'
	));
	$wp_customize->add_control('dog_groomer_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','dog-groomer'),
		'section' => 'dog_groomer_header_section_settings',
		'choices' => array(
         'None' => __('None','dog-groomer'),
         'Zoom In' => __('Zoom In','dog-groomer'),
      ),
	));

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'dog_groomer_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'dog-groomer' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'dog-groomer' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'dog_groomer_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'dog-groomer' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'dog_groomer_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'dog-groomer' ),
            'section'     => 'dog_groomer_slider_section_settings',
            'type'        => 'checkbox',
        )
    );
    
    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'dog_groomer_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'dog_groomer_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'dog_groomer_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Slides','dog-groomer'),
            'section' => 'dog_groomer_slider_section_settings',
        )
    );

    /** Classes Section Settings */
    $wp_customize->add_section(
        'dog_groomer_classes_section_settings',
        array(
            'title' => esc_html__( 'Product Section Settings', 'dog-groomer' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'dog_groomer_home_page_settings',
        )
    );

    /** Classes Section control */
    $wp_customize->add_setting( 
        'dog_groomer_classes_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_classes_setting',
        array(
            'label'       => __( 'Show product Section', 'dog-groomer' ),
            'section'     => 'dog_groomer_classes_section_settings',
            'type'        => 'checkbox',
        )
    );

    $args = array(
        'type'                     => 'product',
        'child_of'                 => 0,
        'parent'                   => '',
        'orderby'                  => 'term_group',
        'order'                    => 'ASC',
        'hide_empty'               => false,
        'hierarchical'             => 1,
        'number'                   => '',
        'taxonomy'                 => 'product_cat',
        'pad_counts'               => false
    );
    $categories = get_categories($args);
    $cat_posts = array();
    $m = 0;
    $cat_posts[]='Select';
    foreach($categories as $category){
        if($m==0){
            $default = $category->slug;
            $m++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting('dog_groomer_hot_products_cat',array(
        'default'   => 'select',
        'sanitize_callback' => 'dog_groomer_sanitize_choices',
    ));
    $wp_customize->add_control('dog_groomer_hot_products_cat',array(
        'type'    => 'select',
        'choices' => $cat_posts,
        'label' => __('Select category to display products ','dog-groomer'),
        'section' => 'dog_groomer_classes_section_settings',
    ));
    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'dog_groomer_footer_section',
        array(
            'title' => __( 'Footer Settings', 'dog-groomer' ),
            'priority' => 70,
            'panel' => 'dog_groomer_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('dog_groomer_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'dog_groomer_sanitize_choices',
    ));

    $wp_customize->add_control('dog_groomer_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'dog-groomer'),
        'section'  => 'dog_groomer_footer_section',
        'settings' => 'dog_groomer_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'dog-groomer'),
		   '2'     => __('Two', 'dog-groomer'),
		   '3'     => __('Three', 'dog-groomer'),
		   '4'     => __('Four', 'dog-groomer')
        ),
    ));

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'dog_groomer_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'dog-groomer' ),
            'section'     => 'dog_groomer_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'dog_groomer_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'dog_groomer_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'dog-groomer' ),
            'section' => 'dog_groomer_footer_section',
            'type' => 'text',
        )
    );  
$wp_customize->add_setting('dog_groomer_footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'dog_groomer_footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'dog-groomer'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'dog-groomer'), 1024, 800),
                'section' => 'dog_groomer_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('dog_groomer_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'dog_groomer_sanitize_choices',
    ));

    $wp_customize->add_control('dog_groomer_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'dog-groomer'),
        'section'  => 'dog_groomer_footer_section',
        'settings' => 'dog_groomer_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','dog-groomer'),
            'scroll' => __('scroll','dog-groomer'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'dog_groomer_footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'dog_groomer_footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'dog-groomer'),
                'section' => 'dog_groomer_footer_section',
                'type' => 'color',
            )
        )
    );

   /** Scroll to top control */
    $wp_customize->add_setting( 
        'dog_groomer_scroll_to_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'dog_groomer_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'dog_groomer_scroll_to_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'dog-groomer' ),
            'section'     => 'dog_groomer_footer_section',
            'type'        => 'checkbox',
        )
    );

     $wp_customize->add_setting('dog_groomer_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Dog_Groomer_Changeable_Icon(
        $wp_customize,'dog_groomer_scroll_icon',array(
        'label' => __('Scroll Top Icon','dog-groomer'),
        'transport' => 'refresh',
        'section'   => 'dog_groomer_footer_section',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting('dog_groomer_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'dog_groomer_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('dog_groomer_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','dog-groomer'),
        'section' => 'dog_groomer_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','dog-groomer'),
            'center-align' => __('Center Alignment','dog-groomer'),
            'left-align' => __('Left Alignment','dog-groomer'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('dog_groomer_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'dog_groomer_sanitize_choices',
    ));

    $wp_customize->add_control('dog_groomer_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'dog-groomer'),
        'section'  => 'dog_groomer_footer_section',
        'settings' => 'dog_groomer_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'dog-groomer' ),
            'curved-box' => __( 'Curved Box', 'dog-groomer' ),
            'circle'     => __( 'Circle', 'dog-groomer' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'dog_groomer_404_section',
        array(
            'title' => __( '404 Page Settings', 'dog-groomer' ),
            'priority' => 70,
            'panel' => 'dog_groomer_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'dog-groomer'),
        'section' => 'dog_groomer_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'dog-groomer'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'dog-groomer'),
        'section' => 'dog_groomer_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'dog-groomer'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'dog-groomer'),
        'section' => 'dog_groomer_404_section',
    ));

}
add_action( 'customize_register', 'dog_groomer_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function dog_groomer_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $dog_groomer_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $dog_groomer_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'dog_groomer_customizer', get_template_directory_uri() . '/js' . $dog_groomer_build . '/customizer' . $dog_groomer_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'dog_groomer_customize_preview_js' );